// Code generated by go-swagger; DO NOT EDIT.

package read

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/ory/keto/internal/httpclient/models"
)

// GetExpandReader is a Reader for the GetExpand structure.
type GetExpandReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetExpandReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetExpandOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetExpandBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetExpandNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetExpandInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetExpandOK creates a GetExpandOK with default headers values
func NewGetExpandOK() *GetExpandOK {
	return &GetExpandOK{}
}

/* GetExpandOK describes a response with status code 200, with default header values.

expandTree
*/
type GetExpandOK struct {
	Payload *models.ExpandTree
}

func (o *GetExpandOK) Error() string {
	return fmt.Sprintf("[GET /expand][%d] getExpandOK  %+v", 200, o.Payload)
}
func (o *GetExpandOK) GetPayload() *models.ExpandTree {
	return o.Payload
}

func (o *GetExpandOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ExpandTree)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetExpandBadRequest creates a GetExpandBadRequest with default headers values
func NewGetExpandBadRequest() *GetExpandBadRequest {
	return &GetExpandBadRequest{}
}

/* GetExpandBadRequest describes a response with status code 400, with default header values.

The standard error format
*/
type GetExpandBadRequest struct {
	Payload *GetExpandBadRequestBody
}

func (o *GetExpandBadRequest) Error() string {
	return fmt.Sprintf("[GET /expand][%d] getExpandBadRequest  %+v", 400, o.Payload)
}
func (o *GetExpandBadRequest) GetPayload() *GetExpandBadRequestBody {
	return o.Payload
}

func (o *GetExpandBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetExpandBadRequestBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetExpandNotFound creates a GetExpandNotFound with default headers values
func NewGetExpandNotFound() *GetExpandNotFound {
	return &GetExpandNotFound{}
}

/* GetExpandNotFound describes a response with status code 404, with default header values.

The standard error format
*/
type GetExpandNotFound struct {
	Payload *GetExpandNotFoundBody
}

func (o *GetExpandNotFound) Error() string {
	return fmt.Sprintf("[GET /expand][%d] getExpandNotFound  %+v", 404, o.Payload)
}
func (o *GetExpandNotFound) GetPayload() *GetExpandNotFoundBody {
	return o.Payload
}

func (o *GetExpandNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetExpandNotFoundBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetExpandInternalServerError creates a GetExpandInternalServerError with default headers values
func NewGetExpandInternalServerError() *GetExpandInternalServerError {
	return &GetExpandInternalServerError{}
}

/* GetExpandInternalServerError describes a response with status code 500, with default header values.

The standard error format
*/
type GetExpandInternalServerError struct {
	Payload *GetExpandInternalServerErrorBody
}

func (o *GetExpandInternalServerError) Error() string {
	return fmt.Sprintf("[GET /expand][%d] getExpandInternalServerError  %+v", 500, o.Payload)
}
func (o *GetExpandInternalServerError) GetPayload() *GetExpandInternalServerErrorBody {
	return o.Payload
}

func (o *GetExpandInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetExpandInternalServerErrorBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetExpandBadRequestBody get expand bad request body
swagger:model GetExpandBadRequestBody
*/
type GetExpandBadRequestBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this get expand bad request body
func (o *GetExpandBadRequestBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this get expand bad request body based on context it is used
func (o *GetExpandBadRequestBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *GetExpandBadRequestBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetExpandBadRequestBody) UnmarshalBinary(b []byte) error {
	var res GetExpandBadRequestBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetExpandInternalServerErrorBody get expand internal server error body
swagger:model GetExpandInternalServerErrorBody
*/
type GetExpandInternalServerErrorBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this get expand internal server error body
func (o *GetExpandInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this get expand internal server error body based on context it is used
func (o *GetExpandInternalServerErrorBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *GetExpandInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetExpandInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetExpandInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetExpandNotFoundBody get expand not found body
swagger:model GetExpandNotFoundBody
*/
type GetExpandNotFoundBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this get expand not found body
func (o *GetExpandNotFoundBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this get expand not found body based on context it is used
func (o *GetExpandNotFoundBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *GetExpandNotFoundBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetExpandNotFoundBody) UnmarshalBinary(b []byte) error {
	var res GetExpandNotFoundBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
